/*
 * elastic.h
 *
 *      Author: David Fernandez Lopez
 *      Debris Collector Core
 */
 
#include "model.h"

#ifndef ELASTIC_H_
#define ELASTIC_H_

void cross_product(EuclideanVector* v1, EuclideanVector* v2, EuclideanVector* result1, EuclideanVector* result2);
float scalar_product(EuclideanVector* v1, EuclideanVector* v2);
int choose(EuclideanVector* f0, EuclideanVector* f1, EuclideanVector* v0);
void closeness(EuclideanVector* D);
void orbit_speed(ProjectableSpaceObject* so, EuclideanVector* v);
void distance_vector(Point* p1, Point* p2, EuclideanVector* v);
void quaternion(EuclideanVector* v1, EuclideanVector* v2, float* x, float* y, float* z, float* w);
#endif /* ELASTIC_H_ */
