/*
 * particle.h
 *
 *      Author: David Fernandez Lopez
 *      Debris Collector Core
 */

#include <vector>
#include "model.h"

#ifndef PARTICLE_H
#define PARTICLE_H

/*
Struct distance
*/
struct Distance{
	Point* point;
	float real_distance;
	float expected_distance;
	float error;
};


/*
Class Particle
*/
class Particle{
	std::vector<Distance*> distances;

	public:
	Point* current_point;
	EuclideanVector* mov;
	float* fitness;
	double* error;
	double* prev_error;
	Particle();
	Particle(float r, float polar, float azimuth, float vx, float vy, float vz);
	~Particle();
	void loadDistance(Point* p, float dist);
	void loadDistance(float r, float polar, float azimuth, float dist);
	void move_particle(float speed, std::vector<std::vector<float> > rotation);
	void load(Particle* particle);
};

/*
Class ParticleList
*/
class ParticleList{
	public:
	std::vector<Particle*> particles;
	ParticleList(bool random);
	~ParticleList();
	double move(float speed, std::vector<std::vector<float> > rotation);
	int resample();
	void computeMedium(Point* p, EuclideanVector* v);
};

#endif
